---
title: XMLHttpRequest.getAllResponseHeaders()
slug: Web/API/XMLHttpRequest/getAllResponseHeaders
tags:
  - API
  - Fetch Headers
  - Get Headers
  - HTTP
  - HTTP Header
  - Method
  - Reference
  - Response Header
  - XHR
  - XMLHttpRequest
  - getAllResponseHeaders
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The {{domxref("XMLHttpRequest")}} method <code><strong>getAllResponseHeaders()</strong></code> returns all the response headers, separated by {{Glossary('CRLF')}}, as a string, or returns <code>null</code> if no response has been received.</span> If a network error happened, an empty string is returned.</p>

<div class="note">
<p><strong>Note:</strong> For multipart requests, this returns the headers from the <em>current</em> part of the request, not from the original channel.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var headers = <var>XMLHttpRequest</var>.getAllResponseHeaders();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("ByteString")}} representing all of the response's headers (except those whose field name is <code>Set-Cookie</code> or <code>Set-Cookie2</code>) separated by {{Glossary('CRLF')}}, or <code>null</code> if no response has been received. If a network error happened, an empty string is returned.</p>

<p>An example of what a raw header string looks like:</p>

<pre><span class="punctuation token">date: Fri, 08 Dec 2017 21:04:30 GMT\r\n
content-encoding: gzip\r\n
x-content-type-options: nosniff\r\n
server: meinheld/0.6.1\r\n
x-frame-options: DENY\r\n
content-type: text/html; charset=utf-8\r\n
connection: keep-alive\r\n
strict-transport-security: max-age=63072000\r\n
vary: Cookie, Accept-Encoding\r\n
content-length: 6502\r\n
x-xss-protection: 1; mode=block\r\n</span></pre>

<p>Each line is terminated by both carriage return and line feed characters (<code>\r\n</code>). These are essentially delimiters separating each of the headers.</p>

<div class="notecard note">
<p><strong>Note</strong>: In modern browsers, the header names are returned in all lower case, as per the latest spec.</p>
</div>

<h2 id="Example">Example</h2>

<p>This example examines the headers in the request's {{event("readystatechange")}} event handler, {{domxref("XMLHttpRequest.onreadystatechange")}}. The code shows how to obtain the raw header string, as well as how to convert it into an array of individual headers and then how to take that array and create a mapping of header names to their values.</p>

<pre class="brush: html">var request = new XMLHttpRequest();
request.open("GET", "foo.txt", true);
request.send();

request.onreadystatechange = function() {
  if(this.readyState == this.HEADERS_RECEIVED) {

    // Get the raw header string
    var headers = request.getAllResponseHeaders();

    // Convert the header string into an array
    // of individual headers
    var arr = headers.trim().split(/[\r\n]+/);

    // Create a map of header names to values
    var headerMap = {};
    arr.forEach(function (line) {
      var parts = line.split(': ');
      var header = parts.shift();
      var value = parts.join(': ');
      headerMap[header] = value;
    });
  }
}</pre>

<p>Once this is done, you can, for example:</p>

<pre class="brush: js">var contentType = headerMap["content-type"];</pre>

<p>This obtains the value of the {{httpheader("Content-Type")}} header into the variable <code>contentType</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-getallresponseheaders()-method', 'getAllResponseHeaders()')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XMLHttpRequest.getAllResponseHeaders")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li>Setting request headers: {{domxref("XMLHttpRequest.setRequestHeader", "setRequestHeader()")}}</li>
</ul>
